Subject: Re: [2.6 patch] unexport icmpmsg_statistics

From: Vlad Yasevich <[email-masked]>
Date: Wed, 24 Oct 2007 17:00:16 -0400

David Stevens wrote:
> My bad -- I see what it's doing, and it looks ok after all.
> 
> I thought I saw an INMSGS (but didn't).  These are ICMP errors that
> went through icmp_rcv() and were counted correctly before getting
> to the protocol error handlers. These are failures due mostly to not
> having enough, or the right protocol info in the error packet being
> handled. I'm not sure I'd count those as ICMP errors, since the
> ICMP header itself is correct, but ok...
> 
> SCTP doesn't look so bad, though I think the references are
> still questionable (but debatable) as ICMP errors.
> 
> sctp_v4_err is incrementing ICMP_MIB_INERRORS if there
> isn't enough IP header to find the ports, I see. I'm not sure
> that counts as an ICMP error, but it's not so terrible.
> 
> It's doing the same thing if a lookup fails to match "vtag" from
> the encapsulated error packet. Again, I don't know that those
> are ICMP errors (which normally are something wrong with
> the ICMP header).

This particular case is the one that bugs the most, but that
error matches best.

Seems like all ULPs treat socket lookup error as ICMP_MIB_INERRORS
(tcp, udp, sctp, dccp).

SCTP is a little special in that in needs to check one one piece
of data (the 'vtag') to correctly identify the connection.
If that piece doesn't match, we treat that as the same error.

-vlad